#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef __MSDOS__
#include <alloc.h>
typedef unsigned long uint32_t;
typedef unsigned short uint16_t;
typedef unsigned char uint8_t;
#else
#include <malloc.h>
#include <stdint.h>
#endif

#define LIST_LEN(x) ((int)(sizeof((x)) / sizeof((x)[0])))

static uint8_t datastart[] = {
  /* xor first byte to avoid use this tool on itself */
  0x4E ^ 0xFF, 0x6F, 0x20, 0x54, 0x69, 0x6D, 0x65, 0x72, 0x73, 0x20, 0x41, 0x76,
  0x61, 0x69, 0x6C, 0x61, 0x62, 0x6C, 0x65, 0x0A, 0x00, 0x00, 0x00, 0x00
};

static char sections[] =
  "CINEMAS\0"
  "END\0"
  "ITEMS\0"
  "COPYRIGHT\0"
  "LASTLEVEL\0"
  "CREDITS\0"
  "PASSWORDS\0"
  "PASSINFO\0"
  "EOF\0";

char *basename(char *s) {
char *r;
  if (s) {
    for (r = s; *r; r++) {
      if ((*r == '/') || (*r == '\\')) {
        s = &r[1];
      }
    }
  }
  return(s);
}

void newext(char *name, char *ext) {
char *p;
  if (name && ext) {
    for (; (*name == '.'); name++);
    for (p = NULL; *name; name++) {
      if (*name == '.') {
        p = name;
      }
    }
    strcpy(p ? p : name, ext);
  }
}

void BuildLookupTable(uint8_t *q, uint16_t qs, uint8_t *t) {
uint16_t i;
  if (q && qs && t) {
    memset(t, qs, 256);
    qs--;
    for (i = 0; i < qs; i++) {
      t[q[i]] = qs - i;
    }
  }
}

uint16_t BoyerMooreHorspool(uint8_t *p, uint16_t ps, uint8_t *q, uint16_t qs, uint8_t *t) {
uint16_t i, s;
  if (p && ps && q && qs) {
    qs--;
    s = 0;
    while ((ps - s) > qs) {
      for (i = qs; (p[s + i] == q[i]); i--) {
        if (!i) {
          return(s + 1);
        }
      }
      s += t[p[s + qs]];
    }
  }
  return(0);
}

/* static buffer for real mode, max sign-safe 16bit value */
static uint8_t buffer[0x8000U];

uint32_t FindData(FILE *fl, uint8_t *data, uint16_t much, uint32_t offs, uint32_t size) {
uint32_t full, find;
uint8_t table[256];
uint16_t l, w;
  /* by default - not found */
  find = 0;
  /* get file size */
  fseek(fl, 0, SEEK_END);
  full = ftell(fl);
  /* check offset */
  offs = (offs < full) ? offs : full;
  if (!size) {
    /* whole file from current offset if size not specified */
    size = full - offs;
  } else {
    /* block size where to find */
    size = ((offs + size) <= full) ? size : (full - offs);
  }
  /* go to requred place */
  fseek(fl, offs, SEEK_SET);
  /* search */
  BuildLookupTable(data, much, table);
  /* at least one whole block available */
  while (size >= much) {
    l = (size < sizeof(buffer)) ? size : sizeof(buffer);
    size -= l;
    fread(buffer, l, 1, fl);
    w = BoyerMooreHorspool(buffer, l, data, much, table);
    /* block found */
    if (w) {
      /* offset +1 if found */
      find = ftell(fl) - l + (w - 1) + 1;
      break;
    } else {
      /* block not found and it's not partial (last) block */
      if (l == sizeof(buffer)) {
        w = much - table[buffer[l - 1]];
        fseek(fl, ftell(fl) - w, SEEK_SET);
        size += w;
      }
    }
  }
  return(find);
}

int main(int argc, char *argv[]) {
char s[260], *x;
uint8_t p[0x2000];
uint16_t i, j;
FILE *fl;
  printf(
    "Exhumed / PowerSlave executable message decrypter v1.1\n"
    "(c) -=CHE@TER=- 2010,2024\n"
    "http://ctpax-cheater.losthost.org/htmldocs/ps_vs_ex.htm\n\n"
  );
  if (argc != 2) {
    printf("Usage: expsmsgd <filename.exe>\n\n");
    return(1);
  }
  fl = fopen(argv[1], "rb");
  if (!fl) {
    printf("Error: can not open input file for read.\n\n");
    return(2);
  }
  /* some kind of trick to avoid use this tool on itself */
  datastart[0] ^= 0xFF;
  fseek(fl, FindData(fl, datastart, sizeof(datastart), 0, 0), SEEK_SET);
  if (!ftell(fl)) {
    fclose(fl);
    printf("Error: string block not found in this file.\n\n");
    return(3);
  }
  fseek(fl, ftell(fl) - 1 + sizeof(datastart), SEEK_SET);
  /* should be enough for all 5 executables */
  memset(p, 0, sizeof(p));
  fread(p, sizeof(p), 1, fl);
  fclose(fl);
  strcpy(s, basename(argv[1]));
  newext(s, ".TXT");
  printf("Extracting and decrypting text to \"%s\"...", s);
  fl = fopen(s, "wb");
  if (!fl) {
    printf("error creating output file!\n\n");
    return(4);
  }
  j = 0;
  for (i = 0; i < sizeof(p); i++) {
    if (p[i]) {
      s[j] = (p[i] ^ 0xFF);
      j++;
      if (j == LIST_LEN(s)) {
        fwrite(s, j, 1, fl);
        j = 0;
      }
    } else {
      if ((!j) && (i == 3452)) { break; } /* BETA */
      /* check section */
      s[j] = 0;
      x = sections;
      while (*x) {
        if (!strcmp(s, x)) {
          break;
        }
        x += strlen(x) + 1;
      }
      if (*x) {
        p[0] = '[';
        fwrite(p, 1, 1, fl);
      }
      fwrite(s, j, 1, fl);
      j = 0;
      if (*x) {
        p[0] = ']';
        fwrite(p, 1, 1, fl);
      }
      s[0] = '\r'; s[1] = '\n';
      fwrite(s, 2, 1, fl);
      /* check for last section [EOF] */
      if (*x) {
        x += strlen(x) + 1;
        if (!*x) { break; } /* DEMO / FULL */
      }
    }
  }
  fclose(fl);
  printf("done\n\n");
  return(0);
}
